/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.utils.flowVisualizationUtils;

import java.util.Vector;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.gui.events.StringValueModificationEvent;
import org.visnow.vn.gui.events.StringValueModificationListener;
import org.visnow.vn.gui.widgets.RunButton;
import static org.visnow.vn.lib.utils.flowVisualizationUtils.StreamlinesShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw ICM
 * <p>
 * Revisions above 564 modified by Szymon Jaranowski (s.jaranowski@icm.edu.pl),
 * University of Warsaw, Interdisciplinary Centre for Mathematical and Computational Modelling
 */
public class StreamlinesGUI extends javax.swing.JPanel
{
    private ParameterProxy parameterProxy = null;

    public StreamlinesGUI()
    {
        initComponents();
    }

    /**
     * Bind parameterproxy to this gui
     *
     * @param targetParameterProxy proxy to target parameters
     */
    public void setParameterProxy(ParameterProxy targetParameterProxy)
    {
        this.parameterProxy = runButton.getPlainProxy(targetParameterProxy, RUNNING_MESSAGE);
    }
    
    public void setSeedPointParams(SeedPointParams seedPointParams)
    {
        seedPointsGUI.setSeedParams(seedPointParams);
    }
    

    public void update(ParameterProxy p, boolean setRunButtonPending)
    {
        vectorComponentSelector.setListData(p.get(META_VECTOR_COMPONENT_NAMES));
        vectorComponentSelector.setSelectedItem(p.get(COMPONENT));
        fireComponentNameListeners((String) vectorComponentSelector.getSelectedItem());

        stepSlider.setValue(parameterProxy.get(STEP));

        String s = String.format("%d", parameterProxy.get(NUM_STEPS_FORWARD));
        fwdStepsCombo.setSelectedItem(s);
        s = String.format("%d", parameterProxy.get(NUM_STEPS_BACKWARD));
        bckStepsCombo.setSelectedItem(s);

        runButton.updateAutoState(p.get(RUNNING_MESSAGE));
        runButton.updatePendingState(setRunButtonPending);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        vectorComponentSelector = new org.visnow.vn.gui.widgets.WidePopupComboBox();
        stepSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        runButton = new org.visnow.vn.gui.widgets.RunButton();
        periodicityBox = new javax.swing.JCheckBox();
        integrationStepsPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        fwdStepsCombo = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        bckStepsCombo = new javax.swing.JComboBox();
        seedPointsGUI = new org.visnow.vn.lib.utils.flowVisualizationUtils.SeedPointsGUI();
        jPanel2 = new javax.swing.JPanel();

        setMinimumSize(new java.awt.Dimension(200, 860));
        setPreferredSize(new java.awt.Dimension(220, 870));
        setLayout(new java.awt.GridBagLayout());

        vectorComponentSelector.setBorder(javax.swing.BorderFactory.createTitledBorder("Vector component"));
        vectorComponentSelector.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                vectorComponentSelectorUserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(vectorComponentSelector, gridBagConstraints);

        stepSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        stepSlider.setMax(0.1);
        stepSlider.setMin(1e-4);
        stepSlider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        stepSlider.setSubmitOnAdjusting(false);
        stepSlider.setValue(2e-3);
        stepSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("Integration step"));
        stepSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                stepSliderUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(stepSlider, gridBagConstraints);

        runButton.setAutoCB(true);
        runButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                runButtonUserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        add(runButton, gridBagConstraints);

        periodicityBox.setText(" compute periodicity index");
        periodicityBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                periodicityBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 0, 0);
        add(periodicityBox, gridBagConstraints);

        integrationStepsPanel.setLayout(new java.awt.GridLayout(2, 2));

        jLabel1.setText("  forward steps");
        integrationStepsPanel.add(jLabel1);

        fwdStepsCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "10", "20", "50", "100", "200", "500", "1000", "2000" }));
        fwdStepsCombo.setSelectedIndex(5);
        fwdStepsCombo.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                fwdStepsComboItemStateChanged(evt);
            }
        });
        integrationStepsPanel.add(fwdStepsCombo);

        jLabel2.setText("  backward steps");
        integrationStepsPanel.add(jLabel2);

        bckStepsCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "10", "20", "50", "100", "200", "500", "1000", "2000" }));
        bckStepsCombo.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                bckStepsComboItemStateChanged(evt);
            }
        });
        integrationStepsPanel.add(bckStepsCombo);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(integrationStepsPanel, gridBagConstraints);

        seedPointsGUI.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        seedPointsGUI.setMinimumSize(new java.awt.Dimension(180, 580));
        seedPointsGUI.setPreferredSize(new java.awt.Dimension(200, 720));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(seedPointsGUI, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 0.6;
        add(jPanel2, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void stepSliderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_stepSliderUserChangeAction
    {//GEN-HEADEREND:event_stepSliderUserChangeAction
        parameterProxy.set(STEP, (Float) stepSlider.getValue());
    }//GEN-LAST:event_stepSliderUserChangeAction

    private void runButtonUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_runButtonUserChangeAction
    {//GEN-HEADEREND:event_runButtonUserChangeAction
        parameterProxy.set(RUNNING_MESSAGE, (RunButton.RunState) evt.getEventData());
    }//GEN-LAST:event_runButtonUserChangeAction

    private void vectorComponentSelectorUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_vectorComponentSelectorUserChangeAction
    {//GEN-HEADEREND:event_vectorComponentSelectorUserChangeAction
//        stepSlider.setValue(parameterProxy.get(META_PREFERRED_STEPS)[vectorComponentSelector.getSelectedIndex()]);
        parameterProxy.set(COMPONENT, (String) vectorComponentSelector.getSelectedItem(),
                           STEP, stepSlider.getValue().floatValue());
        fireComponentNameListeners((String) vectorComponentSelector.getSelectedItem());
    }//GEN-LAST:event_vectorComponentSelectorUserChangeAction

    private void periodicityBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_periodicityBoxActionPerformed
        parameterProxy.set(COMPUTE_PERIODICITY, periodicityBox.isSelected());
    }//GEN-LAST:event_periodicityBoxActionPerformed

    private void fwdStepsComboItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_fwdStepsComboItemStateChanged
    {//GEN-HEADEREND:event_fwdStepsComboItemStateChanged
        int last = parameterProxy.get(NUM_STEPS_FORWARD);    
        try {
            parameterProxy.set(NUM_STEPS_FORWARD, Integer.parseInt((String)fwdStepsCombo.getSelectedItem()));
        } catch (Exception e) {
            fwdStepsCombo.setSelectedItem("" + last);
        }
    }//GEN-LAST:event_fwdStepsComboItemStateChanged

    private void bckStepsComboItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_bckStepsComboItemStateChanged
    {//GEN-HEADEREND:event_bckStepsComboItemStateChanged
        int last = parameterProxy.get(NUM_STEPS_BACKWARD);       
        try {
            parameterProxy.set(NUM_STEPS_BACKWARD, Integer.parseInt((String)bckStepsCombo.getSelectedItem()));
        } catch (Exception e) {
            bckStepsCombo.setSelectedItem("" + last);
        } 
    }//GEN-LAST:event_bckStepsComboItemStateChanged

    public SeedPointsGUI getSeedPointsGUI()
    {
        return seedPointsGUI;
    }
    
    private Vector<StringValueModificationListener> componentNameListeners = new Vector<>();
    
    public void addComponentNameListener(StringValueModificationListener componentNameListener)
    {
        componentNameListeners.add(componentNameListener);
    }
    
    public void removeComponentNameListener(StringValueModificationListener componentNameListener)
    {
        componentNameListeners.remove(componentNameListener);
    }
    
    public void clearComponentNameListeners()
    {
        componentNameListeners.clear();
    }
    
    protected void fireComponentNameListeners(String s)
    {
        for (StringValueModificationListener componentNameListener : componentNameListeners)
            componentNameListener.stringValueChanged(new StringValueModificationEvent(this, s));
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox bckStepsCombo;
    private javax.swing.JComboBox fwdStepsCombo;
    private javax.swing.JPanel integrationStepsPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JCheckBox periodicityBox;
    private org.visnow.vn.gui.widgets.RunButton runButton;
    private org.visnow.vn.lib.utils.flowVisualizationUtils.SeedPointsGUI seedPointsGUI;
    private org.visnow.vn.gui.widgets.ExtendedSlider stepSlider;
    private org.visnow.vn.gui.widgets.WidePopupComboBox vectorComponentSelector;
    // End of variables declaration//GEN-END:variables
}
